Index: trunk/LMDZ.TITAN/libf/muphytitan/fsystem.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/fsystem.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/muphytitan/fsystem.F90	(revision 3083)
@@ -1,39 +1,27 @@
-! Copyright Jérémie Burgalat (2010-2015,2017)
-! 
-! jeremie.burgalat@univ-reims.fr
-! 
-! This software is a computer program whose purpose is to provide configuration 
-! file and command line arguments parsing features to Fortran programs.
-! 
-! This software is governed by the CeCILL-B license under French law and
-! abiding by the rules of distribution of free software.  You can  use, 
-! modify and/ or redistribute the software under the terms of the CeCILL-B
-! license as circulated by CEA, CNRS and INRIA at the following URL
-! "http://www.cecill.info". 
-! 
-! As a counterpart to the access to the source code and  rights to copy,
-! modify and redistribute granted by the license, users are provided only
-! with a limited warranty  and the software's author,  the holder of the
-! economic rights,  and the successive licensors  have only  limited
-! liability. 
-! 
-! In this respect, the user's attention is drawn to the risks associated
-! with loading,  using,  modifying and/or developing or reproducing the
-! software by the user in light of its specific status of free software,
-! that may mean  that it is complicated to manipulate,  and  that  also
-! therefore means  that it is reserved for developers  and  experienced
-! professionals having in-depth computer knowledge. Users are therefore
-! encouraged to load and test the software's suitability as regards their
-! requirements in conditions enabling the security of their systems and/or 
-! data to be ensured and,  more generally, to use and operate it in the 
-! same conditions as regards security. 
-! 
-! The fact that you are presently reading this means that you have had
-! knowledge of the CeCILL-B license and that you accept its terms.
+! Copyright (c) (2013-2015,2017) Jeremie Burgalat (jeremie.burgalat@univ-reims.fr).
+!
+! This file is part of SWIFT
+!
+! Permission is hereby granted, free of charge, to any person obtaining a copy of
+! this software and associated documentation files (the "Software"), to deal in
+! the Software without restriction, including without limitation the rights to
+! use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
+! the Software, and to permit persons to whom the Software is furnished to do so,
+! subject to the following conditions:
+!
+! The above copyright notice and this permission notice shall be included in all
+! copies or substantial portions of the Software.
+!
+! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
+! FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
+! COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
+! IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
+! CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 
 !! file: fsystem.F90
 !! summary: File system methods source file.
 !! author: J. Burgalat
-!! date: 2013-2015,2017
+!! date: 2013-2015,2017,2022
 
 
@@ -46,5 +34,5 @@
   IMPLICIT NONE
 
-  PUBLIC 
+  PUBLIC
 
   PRIVATE :: get_umask
@@ -57,13 +45,13 @@
     !!
     !! This object can be used to get an approximation of the execution of some piece of code.
-    REAL(kind=8), PRIVATE    :: cpu_start = 0d0   
+    REAL(kind=8), PRIVATE    :: cpu_start = 0d0
       !! Starting CPU time
-    INTEGER(kind=8), PRIVATE :: clock_start = 0d0 
+    INTEGER(kind=8), PRIVATE :: clock_start = 0d0
       !! Starting clock time
     LOGICAL, PRIVATE         :: on_run = .false.
       !! Chrono running state.
 #if HAVE_FTNPROC
-    CONTAINS 
-      PROCEDURE :: is_running => chrono_is_running 
+    CONTAINS
+      PROCEDURE :: is_running => chrono_is_running
       PROCEDURE :: start      => chrono_start
       PROCEDURE :: stop       => chrono_stop
@@ -95,5 +83,5 @@
     END FUNCTION errno_c
 
-    FUNCTION usleep_c(usec) BIND(C,name="usleep") 
+    FUNCTION usleep_c(usec) BIND(C,name="usleep")
       !! (attemps to) Sleep for a given number of microseconds
       IMPORT C_INT
@@ -127,5 +115,5 @@
 
     FUNCTION access_c(path,perm) BIND(C,name="c_access")
-      !! Check if path is accessible for current user 
+      !! Check if path is accessible for current user
       IMPORT c_char, C_INT
       CHARACTER(len=c_char), INTENT(in)      :: path(*)  !! Path to check
@@ -134,5 +122,5 @@
     END FUNCTION access_c
 
-    FUNCTION create_c(path,mode,asfile,forced) BIND(C,name="c_create") 
+    FUNCTION create_c(path,mode,asfile,forced) BIND(C,name="c_create")
       !! Create a directory or a file in given path
       IMPORT c_char, C_INT
@@ -149,5 +137,5 @@
       INTEGER(kind=C_INT), INTENT(in), VALUE :: uid     !! User id
       TYPE(C_PTR)                            :: uname_c !! C_PTR to the underlying char* pointer storing user name
-    END FUNCTION uname_c 
+    END FUNCTION uname_c
 
     FUNCTION gname_c(gid) BIND(C, name="c_gname")
@@ -156,7 +144,7 @@
       INTEGER(kind=C_INT), INTENT(in), VALUE :: gid     !! Group id
       TYPE(C_PTR)                            :: gname_c !! C_PTR to the underlying char* pointer storing group name
-    END FUNCTION gname_c 
-
-    FUNCTION dirname_c(path) BIND(C,name="c_dirname") 
+    END FUNCTION gname_c
+
+    FUNCTION dirname_c(path) BIND(C,name="c_dirname")
       !! Get the directory name of the path
       IMPORT c_char, c_ptr
@@ -172,5 +160,5 @@
     END FUNCTION basename_c
 
-    FUNCTION getcwd_c() BIND(C,name="c_getcwd") 
+    FUNCTION getcwd_c() BIND(C,name="c_getcwd")
       !! Get the current working directory
       IMPORT c_ptr
@@ -198,5 +186,5 @@
       CHARACTER(kind=c_char), INTENT(in) :: input(*)  !! Path to rename
       CHARACTER(kind=c_char), INTENT(in) :: output(*) !! New name of the path
-      INTEGER(kind=C_INT)                :: rename_c  !! 0 on success, last errno on failure 
+      INTEGER(kind=C_INT)                :: rename_c  !! 0 on success, last errno on failure
     END FUNCTION rename_c
 
@@ -206,5 +194,5 @@
       CHARACTER(kind=c_char), INTENT(in)     :: path(*) !! Path to modify
       INTEGER(kind=C_INT), INTENT(in), VALUE :: mode    !! New decimal permissions of the path to set
-      INTEGER(kind=C_INT)                    :: chmod_c !! 0 on success, last errno on failure 
+      INTEGER(kind=C_INT)                    :: chmod_c !! 0 on success, last errno on failure
     END FUNCTION chmod_c
 
@@ -213,5 +201,5 @@
       IMPORT c_char, C_INT
       CHARACTER(kind=c_char), INTENT(in)  :: new(*)  !! Path of the new working directory
-      INTEGER(kind=C_INT)                 :: chdir_c !! 0 on success, last errno on failure 
+      INTEGER(kind=C_INT)                 :: chdir_c !! 0 on success, last errno on failure
     END FUNCTION chdir_c
 
@@ -220,6 +208,6 @@
       IMPORT c_char, C_INT
       CHARACTER(kind=c_char), INTENT(in)     :: dirname(*) !! Path of the directory to create
-      INTEGER(kind=C_INT), INTENT(in), VALUE :: mode       !! Decimal permission to set 
-      INTEGER(kind=C_INT)                    :: mkdir_c    !! 0 on success, last errno on failure 
+      INTEGER(kind=C_INT), INTENT(in), VALUE :: mode       !! Decimal permission to set
+      INTEGER(kind=C_INT)                    :: mkdir_c    !! 0 on success, last errno on failure
     END FUNCTION mkdir_c
 
@@ -228,9 +216,9 @@
       IMPORT c_char, C_INT
       CHARACTER(kind=c_char), INTENT(in)     :: dirname(*) !! Path of the directory to create
-      INTEGER(kind=C_INT), INTENT(in), VALUE :: mode       !! Decimal permission to set 
-      INTEGER(kind=C_INT)                    :: mkdirp_c   !! 0 on success, last errno on failure 
+      INTEGER(kind=C_INT), INTENT(in), VALUE :: mode       !! Decimal permission to set
+      INTEGER(kind=C_INT)                    :: mkdirp_c   !! 0 on success, last errno on failure
     END FUNCTION mkdirp_c
 
-    FUNCTION copy_c(to,from) BIND(C,name="c_copy") 
+    FUNCTION copy_c(to,from) BIND(C,name="c_copy")
       !! Copy a file.
       IMPORT c_char, C_INT
@@ -240,9 +228,9 @@
     END FUNCTION copy_c
 
-    FUNCTION remove_c(path) BIND(C,name="c_remove") 
+    FUNCTION remove_c(path) BIND(C,name="c_remove")
       !! Remove a file (or a directory) from the filesystem
       IMPORT c_char, C_INT
       CHARACTER(kind=c_char), INTENT(in)  :: path(*)  !! Path to delete
-      INTEGER(kind=C_INT)                 :: remove_c !! 0 on success, last errno on failure 
+      INTEGER(kind=C_INT)                 :: remove_c !! 0 on success, last errno on failure
     END FUNCTION remove_c
 
@@ -251,5 +239,5 @@
       IMPORT c_char, C_INT
       CHARACTER(kind=c_char), INTENT(in) :: dirpath(*) !! Directory to delete
-      INTEGER(kind=C_INT)                :: rmdir_c    !! 0 on success, last errno on failure 
+      INTEGER(kind=C_INT)                :: rmdir_c    !! 0 on success, last errno on failure
     END FUNCTION rmdir_c
 
@@ -258,5 +246,5 @@
       IMPORT c_char, C_INT
       CHARACTER(kind=c_char), INTENT(in) :: dirpath(*) !! Directory to delete
-      INTEGER(kind=C_INT)                :: rmdirf_c   !! 0 on success, last errno on failure 
+      INTEGER(kind=C_INT)                :: rmdirf_c   !! 0 on success, last errno on failure
     END FUNCTION rmdirf_c
 
@@ -282,5 +270,5 @@
       INTEGER(kind=C_INT), INTENT(out) :: r, &       !! Number of rows
                                           c          !! Number of columns
-      INTEGER(kind=C_INT)              :: termsize_c !! 0 on success, last errno on failure 
+      INTEGER(kind=C_INT)              :: termsize_c !! 0 on success, last errno on failure
     END FUNCTION termsize_c
 
@@ -289,5 +277,5 @@
       IMPORT  C_SIZE_T
       INTEGER(kind=C_SIZE_T) :: getCurrentRSS_c !! Current resident set size in bytes (0 if not available).
-    END FUNCTION getCurrentRSS_c 
+    END FUNCTION getCurrentRSS_c
 
     FUNCTION getPeakRSS_c() BIND(C, name="c_getPeakRSS")
@@ -295,5 +283,5 @@
       IMPORT  C_SIZE_T
       INTEGER(kind=C_SIZE_T) :: getPeakRSS_c !! Peak resident set size in bytes (0 if not available).
-    END FUNCTION getPeakRSS_c 
+    END FUNCTION getPeakRSS_c
 
     FUNCTION getSystemMemory_c(total,avail,free) BIND(C, name='c_getSystemMemory')
@@ -303,5 +291,5 @@
       INTEGER(kind=C_LONG_LONG), INTENT(out) :: avail             !! Current available memory.
       INTEGER(kind=C_LONG_LONG), INTENT(out) :: free              !! Current free memory.
-      INTEGER(kind=C_INT)                    :: getSystemMemory_c !! status, 0 on success, 1 otherwise. 
+      INTEGER(kind=C_INT)                    :: getSystemMemory_c !! status, 0 on success, 1 otherwise.
     END FUNCTION getSystemMemory_c
   END INTERFACE
@@ -311,12 +299,12 @@
 
   FUNCTION fstring(string) RESULT(str)
-    !! Convert C string to  Fortran string 
+    !! Convert C string to  Fortran string
     !!
     !! The method copies the input C string up to the last C_NULL_CHAR found (not including it),
     !! and returns the converted Fortran string.
     !! All other C_NULL_CHAR found in the C string are removed.
-    CHARACTER(len=*), INTENT(in) :: string !! A string from C 
+    CHARACTER(len=*), INTENT(in) :: string !! A string from C
     CHARACTER(len=:), ALLOCATABLE :: str   !! Converted fortran string
-    INTEGER :: i,idx 
+    INTEGER :: i,idx
     str = ""
     idx = INDEX(string,C_NULL_CHAR,.true.)
@@ -335,10 +323,10 @@
     !!
     !! The method build the fortran string from a TYPE(C_PTR) object that represent a
-    !! C char\* pointer string. 
+    !! C char\* pointer string.
     !! @note
     !! If __cstr__ is not allocated (i.e. the C_PTR is not associated) or if it is set
     !! to a C empty string (i.e. '\0') then the method returns an empty string.
     !! @attention
-    !! The method does not free the underlying C string and it should be free using 
+    !! The method does not free the underlying C string and it should be free using
     !! the subroutine free_c(_cstr_).
     TYPE(C_PTR), INTENT(in) :: cstr
@@ -366,8 +354,8 @@
 
   FUNCTION cstring(string) RESULT(str)
-    !> convert Fortran string to cstring 
+    !> convert Fortran string to cstring
     !!
     !! The method returns a copy of the input string suitable for C functions argument.
-    !! @note 
+    !! @note
     !! Input string is trimmed during computations
     CHARACTER(len=*), INTENT(in) :: string
@@ -385,8 +373,8 @@
 !===============================================================================
 
-  FUNCTION fs_getgid() RESULT(ret) 
+  FUNCTION fs_getgid() RESULT(ret)
     !! Get Group ID
     INTEGER(kind=4) :: ret !! An integer with the group identifier
-    ret = INT(getgid_c(),kind=4) 
+    ret = INT(getgid_c(),kind=4)
     RETURN
   END FUNCTION fs_getgid
@@ -399,5 +387,5 @@
   END FUNCTION fs_getpid
 
-  FUNCTION fs_getuid() RESULT(ret) 
+  FUNCTION fs_getuid() RESULT(ret)
     !! Get User ID
     INTEGER(kind=4) :: ret !! An integer with the user identifier
@@ -413,5 +401,5 @@
     zname = gname_c(gid)
     IF (.NOT.C_ASSOCIATED(zname)) THEN
-      gname = "" 
+      gname = ""
     ELSE
       gname = cstr2fstr(zname)
@@ -427,5 +415,5 @@
     zname = gname_c(uid)
     IF (.NOT.C_ASSOCIATED(zname)) THEN
-      uname = "" 
+      uname = ""
     ELSE
       uname = cstr2fstr(zname)
@@ -438,5 +426,5 @@
     CHARACTER(len=*), INTENT(in)  :: path
       !! A string with a (valid) path
-    CHARACTER(len=:), ALLOCATABLE :: opath 
+    CHARACTER(len=:), ALLOCATABLE :: opath
       !! A Fortran allocated string with the parent directory path or an empty string if method fails
     TYPE(C_PTR) :: zpath
@@ -458,5 +446,5 @@
     CHARACTER(len=*), INTENT(in)  :: path
       !! A string with a (valid) path
-    CHARACTER(len=:), ALLOCATABLE :: opath 
+    CHARACTER(len=:), ALLOCATABLE :: opath
       !! The basename of the path or an empty string if method fails
     TYPE(C_PTR) :: zpath
@@ -478,9 +466,9 @@
     !!
     !! The method computes the absolute path of the given path using C realpath function.
-    !! @note 
+    !! @note
     !! If the input path is empty then current working directory is returned.
     CHARACTER(len=*), INTENT(in)  :: path
       !! A string with a (valid) path
-    CHARACTER(len=:), ALLOCATABLE :: opath 
+    CHARACTER(len=:), ALLOCATABLE :: opath
       !! The absolute of the path or an empty string if method fails
     TYPE(C_PTR) :: zpath
@@ -497,5 +485,5 @@
     !! Get the relative representation of two paths
     !!
-    !! The method computes the relative representation of __path__ from __reldir__ if possible. 
+    !! The method computes the relative representation of __path__ from __reldir__ if possible.
     !! If no common prefix is found, the method returns __path__.
     CHARACTER(len=*), INTENT(in) :: path, & !! Path to be computed relative to reldir
@@ -508,9 +496,9 @@
     ELSE
       res = cstr2fstr(zpath)
-    ENDIF 
+    ENDIF
     CALL free_c(zpath)
   END FUNCTION fs_relpath
 
-  FUNCTION fs_getcwd() RESULT(path) 
+  FUNCTION fs_getcwd() RESULT(path)
     !! Get the current working directory
     CHARACTER(len=:), ALLOCATABLE :: path
@@ -558,5 +546,5 @@
     LOGICAL :: ret                         !! True on success, false otherwise.
     IF (LEN_TRIM(old) == 0.OR.LEN_TRIM(new) == 0) THEN
-      ret = .false. 
+      ret = .false.
     ELSE
       ret = INT(rename_c(cstring(ADJUSTL(old)),cstring(ADJUSTL(new)))) == 0
@@ -572,5 +560,5 @@
     INTEGER(kind=C_INT) :: zmode
     IF (LEN_TRIM(path) == 0) THEN
-      ret = .false. 
+      ret = .false.
     ELSE
       zmode = INT(oct_2_dec(mode),kind=C_INT)
@@ -585,5 +573,5 @@
     LOGICAL :: ret                       !! True on success, false otherwise.
     IF (LEN_TRIM(path) == 0) THEN
-      ret = .false. 
+      ret = .false.
     ELSE
       ret = INT(chdir_c(cstring(ADJUSTL(path)))) == 0
@@ -597,5 +585,5 @@
     !! The method attempts to create a new directory pointed by __path__ with the permission
     !! given by mode.
-    CHARACTER(len=*), INTENT(in)  :: path 
+    CHARACTER(len=*), INTENT(in)  :: path
       !! The path to modify
     INTEGER, INTENT(in), OPTIONAL :: mode
@@ -608,14 +596,14 @@
     LOGICAL :: zperm
     IF (LEN_TRIM(path) == 0) THEN
-      ret = .false. 
-    ELSE
-      zmode = oct_2_dec(744) 
+      ret = .false.
+    ELSE
+      zmode = oct_2_dec(744)
       IF (PRESENT(mode)) THEN
-        IF (.NOT.chk_pm(mode)) THEN 
+        IF (.NOT.chk_pm(mode)) THEN
           ret = .false. ; RETURN
         ENDIF
         zmode = oct_2_dec(mode)
       ENDIF
-      zperm = .false. ; IF (PRESENT(permissive)) zperm = permissive 
+      zperm = .false. ; IF (PRESENT(permissive)) zperm = permissive
       IF (zperm) THEN
         ret = INT(mkdirp_c(cstring(ADJUSTL(path)),INT(zmode,kind=C_INT))) == 0
@@ -630,5 +618,5 @@
     !! Remove directory
     !!
-    !! By default, the function removes an __empty__ directory. If __forced__ is given and set 
+    !! By default, the function removes an __empty__ directory. If __forced__ is given and set
     !! to .true. then the function recursively deletes the directory and __ALL__ its content.
     CHARACTER(len=*), INTENT(in)  :: path
@@ -638,7 +626,7 @@
     LOGICAL :: ret
       !! True on success, false otherwise.
-    LOGICAL :: zforce 
+    LOGICAL :: zforce
     IF (LEN_TRIM(path) == 0) THEN
-      ret = .false. 
+      ret = .false.
     ELSE
       zforce = .false. ; IF (PRESENT(forced)) zforce = forced
@@ -655,5 +643,5 @@
     !! Get some informations about a path
     !!
-    !! The method retrieves various informations about the input path using fstat C function. 
+    !! The method retrieves various informations about the input path using fstat C function.
     !! The type of path as returned in __type__ argument is can take the following values:
     !!
@@ -666,5 +654,5 @@
     INTEGER, INTENT(out), OPTIONAL           :: type,  & !! Optional type of path (see function documentation).
                                                 perm,  & !! Optional permission of the path
-                                                nlnks, & !! Optional number of links to the path 
+                                                nlnks, & !! Optional number of links to the path
                                                 uid,   & !! Optional user id
                                                 gid      !! Optional group id
@@ -674,5 +662,5 @@
                                                 ctime    !! Optional creation time
     LOGICAL :: ret                                       !! True on success, false otherwise.
-    INTEGER                       :: ty,pe,ln,ud,gd 
+    INTEGER                       :: ty,pe,ln,ud,gd
     INTEGER(kind=8)               :: fs
     CHARACTER(len=:), ALLOCATABLE :: at,mt,ct
@@ -691,11 +679,11 @@
       ret = INT(fstat_c(cstring(ADJUSTL(path)),p,l,t,u,g,f,ta,tm,tc)) == 0
       IF (ret) THEN
-        pe=INT(p) ; ln=INT(l) ; ty=INT(t) ; ud=INT(u) ; gd=INT(g) 
-        fs=INT(f,kind=8) 
+        pe=INT(p) ; ln=INT(l) ; ty=INT(t) ; ud=INT(u) ; gd=INT(g)
+        fs=INT(f,kind=8)
         at = fstring(ta)
         mt = fstring(tm)
         ct = fstring(tc)
       ENDIF
-      IF (PRESENT(type))  type  = ty 
+      IF (PRESENT(type))  type  = ty
       IF (PRESENT(perm))  perm  = pe
       IF (PRESENT(nlnks)) nlnks = ln
@@ -713,21 +701,21 @@
     !! Check if a path is a directory
     !!
-    !! The method is just a wrapper of [[fsystem(module):fs_stat(function)]] to get only specific 
+    !! The method is just a wrapper of [[fsystem(module):fs_stat(function)]] to get only specific
     !! information about __path__ type.
     CHARACTER(len=*), INTENT(in) :: path !! The path to check
-    LOGICAL :: ret                       !! .true. if the path is a directory, .false. otherwise. 
+    LOGICAL :: ret                       !! .true. if the path is a directory, .false. otherwise.
     INTEGER :: ty
     ret = fs_stat(path,type=ty)
-    ret = ret.AND.(ty==2.or.ty==3) 
+    ret = ret.AND.(ty==2.or.ty==3)
     RETURN
   END FUNCTION fs_isdir
 
   FUNCTION fs_isfile(path) RESULT (ret)
-    !! Check if a path is a file 
-    !!
-    !! The method is just a wrapper of [[fsystem(module):fs_stat(function)]] to get only specific 
+    !! Check if a path is a file
+    !!
+    !! The method is just a wrapper of [[fsystem(module):fs_stat(function)]] to get only specific
     !! information about __path__ type.
     CHARACTER(len=*), INTENT(in) :: path !! The path to check
-    LOGICAL :: ret                       !! .true. if the path is a file, .false. otherwise. 
+    LOGICAL :: ret                       !! .true. if the path is a file, .false. otherwise.
     INTEGER :: ty
     ret=fs_stat(path,type=ty)
@@ -737,11 +725,11 @@
 
   FUNCTION fs_islink(path) RESULT (ret)
-    !! Check if a path is a link 
-    !!
-    !! The method is just a wrapper of [[fsystem(module):fs_stat(function)]] to get only specific 
+    !! Check if a path is a link
+    !!
+    !! The method is just a wrapper of [[fsystem(module):fs_stat(function)]] to get only specific
     !! information about __path__ type.
     CHARACTER(len=*), INTENT(in) :: path !! The path to check
-    LOGICAL :: ret                       !! .true. if the path is a link, .false. otherwise. 
-    INTEGER :: ty 
+    LOGICAL :: ret                       !! .true. if the path is a link, .false. otherwise.
+    INTEGER :: ty
     ret=fs_stat(path,type=ty)
     ret = ret.and.(ty==1.or.ty==3)
@@ -759,5 +747,5 @@
     !! - 1 : Checks for EXECUTE permission
     !! - 2 : Checks for WRITE permission
-    !! - 4 : Checks for READ permission 
+    !! - 4 : Checks for READ permission
     CHARACTER(len=*), INTENT(in)  :: path       !! Path to check
     INTEGER, INTENT(in), OPTIONAL :: permission !! Optional permission to check
@@ -765,5 +753,5 @@
     INTEGER(kind=C_INT) :: zp
     IF (LEN_TRIM(path) == 0) THEN
-      ret = .false. 
+      ret = .false.
     ELSE
       zp = 0 ; IF (PRESENT(permission)) zp = INT(permission,kind=C_INT)
@@ -777,19 +765,19 @@
     !! Split given path into base,extension
     !!
-    !! The __base__ of a path is conventionnally defined as all characters before the last dot of the path. 
-    !! The extension (__ext__) of the path gathers consequently all characters from the last dot to the end 
+    !! The __base__ of a path is conventionnally defined as all characters before the last dot of the path.
+    !! The extension (__ext__) of the path gathers consequently all characters from the last dot to the end
     !! of the string.
     !! @note
-    !! If the basename of the path begins by a dot then the path is assumed to be an hidden file (directory). 
+    !! If the basename of the path begins by a dot then the path is assumed to be an hidden file (directory).
     !! __ext__ will then be empty.
-    CHARACTER(len=*), INTENT(in)               :: path     !! Path to split 
+    CHARACTER(len=*), INTENT(in)               :: path     !! Path to split
     CHARACTER(len=:), INTENT(out), ALLOCATABLE :: base, &  !! Output base of the path
                                                   ext      !! Output extension of the path
-    LOGICAL, INTENT(in), OPTIONAL              :: absolute !! .true. to return absolute path 
-    LOGICAL                       :: ret                   !! .true. on success, .false. otherwise. 
+    LOGICAL, INTENT(in), OPTIONAL              :: absolute !! .true. to return absolute path
+    LOGICAL                       :: ret                   !! .true. on success, .false. otherwise.
     LOGICAL                       :: zabs
     INTEGER                       :: p
     CHARACTER(len=:), ALLOCATABLE :: d,b,apath
-    base = "" ; ext = "" 
+    base = "" ; ext = ""
     ret = .false.
     IF (LEN_TRIM(path) == 0) THEN
@@ -800,5 +788,5 @@
     IF (zabs) THEN
       apath = fs_realpath(path) ; IF (LEN_TRIM(apath) == 0) RETURN
-    ENDIF 
+    ENDIF
     d = fs_dirname(apath) ; IF (LEN_TRIM(d) == 0) RETURN
     b = fs_basename(apath) ; IF (LEN_TRIM(b) == 0) RETURN
@@ -806,7 +794,7 @@
     ! If dot is set as first char of basename : it's an hidden file
     IF (p > 1) THEN
-      ext = b(p:) ; base = TRIM(d)//"/"//b(:p-1) 
-    ELSE
-      base = TRIM(apath) 
+      ext = b(p:) ; base = TRIM(d)//"/"//b(:p-1)
+    ELSE
+      base = TRIM(apath)
     ENDIF
     ret = .true.
@@ -815,5 +803,5 @@
 
   FUNCTION fs_create(path, mode, type, permissive) RESULT(ret)
-    !! Create a directory/file 
+    !! Create a directory/file
     !!
     !! The method creates the file/directory pointed by given __path__.
@@ -827,5 +815,5 @@
     !! Unless __permissive__ is set to .true., the method will fails if intermediate
     !! directories in the path do not exist.
-    CHARACTER(len=*), INTENT(in)           :: path        !! Path to create 
+    CHARACTER(len=*), INTENT(in)           :: path        !! Path to create
     INTEGER, INTENT(in), OPTIONAL          :: mode        !! Optional octal permisions to set
     CHARACTER(len=1), INTENT(in), OPTIONAL :: type        !! Optional type of path to create
@@ -833,5 +821,5 @@
     LOGICAL :: ret                                        !! True on success, false otherwise.
     INTEGER                       :: zmd,zt,zp
-    CHARACTER(len=:), ALLOCATABLE :: b,e 
+    CHARACTER(len=:), ALLOCATABLE :: b,e
     ret = .false.
     ! Checking for existence
@@ -839,10 +827,10 @@
       RETURN
     ELSE IF (fs_access(path)) THEN
-      RETURN 
+      RETURN
     ENDIF
     ! Set type of path
     IF (PRESENT(type)) THEN
       IF (.NOT.(type(1:1)=="f".OR.type(1:1)=="d")) THEN
-        RETURN 
+        RETURN
       ELSE
         zt=0 ; IF (type(1:1)=="f") zt = 1
@@ -854,5 +842,5 @@
     ! set permissions according to type
     IF (zt == 0) THEN
-      zmd = oct_2_dec(777)-get_umask() 
+      zmd = oct_2_dec(777)-get_umask()
     ELSE
       zmd = oct_2_dec(666) -get_umask()
@@ -874,18 +862,18 @@
   FUNCTION fs_get_parent(path, n) RESULT(opath)
     !! Get the nth parent of the given path
-    !! 
-    !! The method first resolves the given path using [[fsystem(module):fs_realpath(function)]] 
+    !!
+    !! The method first resolves the given path using [[fsystem(module):fs_realpath(function)]]
     !! to get an absolute path.
-    !! @note 
+    !! @note
     !! If __n__ is greater than the maximum parent level of the path, "/" is returned.
     CHARACTER(len=*), INTENT(in)  :: path
       !! Input path
-    INTEGER, INTENT(in), OPTIONAL :: n 
+    INTEGER, INTENT(in), OPTIONAL :: n
       !! The level of the parent to get
     CHARACTER(len=:), ALLOCATABLE :: opath
-      !! The nth parent of the given path, or an empty string if the parent can not be computed 
+      !! The nth parent of the given path, or an empty string if the parent can not be computed
     CHARACTER(len=:), ALLOCATABLE :: zp
     INTEGER                       :: i,mx,zl,mzl
-    opath = "" 
+    opath = ""
     zl = 1 ; IF (PRESENT(n)) zl = MAX(n,1)
     IF (LEN_TRIM(path) == 0) THEN
@@ -900,13 +888,13 @@
     mzl = 1 ; DO i=1,mx ; IF(zp(i:i) == '/') mzl=mzl+1 ; ENDDO
     i=0
-    DO 
+    DO
       mx = INDEX(zp(1:mx),'/',.true.) ; i=i+1
-      IF (mx==0.OR.i>=zl.OR.i>=mzl) EXIT 
+      IF (mx==0.OR.i>=zl.OR.i>=mzl) EXIT
       mx = mx - 1
     ENDDO
     IF (mx >= 1) THEN
       opath = zp(1:MAX(1,mx-1))
-    ELSE 
-      opath = "/" 
+    ELSE
+      opath = "/"
     ENDIF
     RETURN
@@ -929,8 +917,8 @@
   SUBROUTINE fs_usleep(usec)
     !! Sleep for a given number of microseconds
-    !! @note 
-    !! Currently if C usleep function failed, the system... does not sleep ! 
+    !! @note
+    !! Currently if C usleep function failed, the system... does not sleep !
     INTEGER, INTENT(in) :: usec !! The number of microseconds to sleep for
-    INTEGER(kind=C_INT) :: ret 
+    INTEGER(kind=C_INT) :: ret
     ! usleep expects useconds_t (unsigned int) which is given here as a 4-bytes int
     ret = usleep_c(INT(usec,kind=C_INT))
@@ -979,10 +967,10 @@
     LOGICAL          :: zpeak
     CHARACTER(len=2) :: zunits
-    INTEGER(kind=8)  :: ztot,zava,zfre    
+    INTEGER(kind=8)  :: ztot,zava,zfre
 
     zunits = 'B '   ; IF (PRESENT(units)) zunits = units
     IF (zunits /= 'B' .AND. zunits /= 'KB' .AND. zunits /= 'MB' .AND. zunits /= 'GB') zunits = 'B '
     ret = INT(getSystemMemory_c(ztot,zava,zfre),kind=4) == 0
-    ztot = ztot * 1024 ; zava = zava * 1024 ; zfre = zfre * 1024 
+    ztot = ztot * 1024 ; zava = zava * 1024 ; zfre = zfre * 1024
 
     IF (PRESENT(total))     total     = ztot
@@ -1014,5 +1002,5 @@
   FUNCTION oct_2_dec(octal) RESULT(res)
     !> Octal to decimal conversion
-    !! 
+    !!
     !! The method converts the octal number ranging from 0 to 777 in the decimal system.
     !! @attention
@@ -1029,5 +1017,5 @@
     ENDDO
     res=d
-    RETURN 
+    RETURN
   END FUNCTION oct_2_dec
 
@@ -1059,9 +1047,9 @@
     !! Get octal number of string representation's permission
     CHARACTER(len=3),INTENT(in) :: str !! The permission to convert
-    INTEGER :: oct                     !! Octal value of the string permission on succes, -1 otherwise. 
+    INTEGER :: oct                     !! Octal value of the string permission on succes, -1 otherwise.
     oct = -1
     IF (LEN_TRIM(str) /= 3) RETURN
     SELECT CASE(str)
-      CASE("---")  ; oct = 0 
+      CASE("---")  ; oct = 0
       CASE("--x")  ; oct = 1
       CASE("-w-")  ; oct = 2
@@ -1071,7 +1059,7 @@
       CASE("rw-")  ; oct = 6
       CASE("rwx")  ; oct = 7
-      CASE DEFAULT 
+      CASE DEFAULT
         oct = -1 ; RETURN
-    END SELECT 
+    END SELECT
     RETURN
   END FUNCTION sp_2_op
@@ -1090,7 +1078,7 @@
       CASE(6) ; str="rw-"
       CASE(7) ; str="rwx"
-      CASE DEFAULT 
+      CASE DEFAULT
         str='ukn' ; RETURN
-    END SELECT 
+    END SELECT
     RETURN
   END FUNCTION op_2_sp
@@ -1098,8 +1086,8 @@
   FUNCTION str_perm(oct_perm) RESULT(ret)
     !! Get the string representation of the given permission mask
-    INTEGER, INTENT(in) :: oct_perm !! The octal representation of the permission 
+    INTEGER, INTENT(in) :: oct_perm !! The octal representation of the permission
     CHARACTER(len=9) :: ret      !! String representation of the octal number on succes, 'ukn' otherwise
     INTEGER :: u,g,o
-    IF (.NOT.chk_pm(oct_perm)) THEN 
+    IF (.NOT.chk_pm(oct_perm)) THEN
       ret = "ukn" ; RETURN
     ENDIF
@@ -1169,5 +1157,5 @@
 
   SUBROUTINE chrono_start(this)
-    !! Start the chrono. 
+    !! Start the chrono.
     !!
     !! @note
@@ -1180,5 +1168,5 @@
     ENDIF
     this%on_run = .true.
-  END SUBROUTINE chrono_start 
+  END SUBROUTINE chrono_start
 
   SUBROUTINE chrono_stop(this)
@@ -1197,11 +1185,11 @@
   END SUBROUTINE chrono_reset
 
-  SUBROUTINE chrono_get(this,cpu,clock,units) 
+  SUBROUTINE chrono_get(this,cpu,clock,units)
     !! Get elapsed time since last call of start or reset methods.
-    !! 
+    !!
     !! The method computes the time elapsed in two ways :
     !!
     !! - If the [[fsystem(module):chrono(type)]] is not running, the method retruns 0.
-    !! - Otherwise, elapsed time since the last call of 
+    !! - Otherwise, elapsed time since the last call of
     !!   [[chrono(type):start(bound)]] (or [[chrono(type):reset(bound)]]).
     OBJECT(chrono), INTENT(in)             :: this
